var bizagiUtil = require('bz-util');
var REQUIRED = bizagiUtil.REQUIRED;
var ERROR = bizagiUtil.error;
var RESPONSE = bizagiUtil.getResponse;
 
/**
 * @author Lianeth Rada
 */ 

function invoke(globals, actionName, data, authenticationType, LOG, callback) {
    /**
     * Tu código va aquí
     */ 
    
    var apiKey = globals.authdata.API_Key;
    var googleTranslate = REQUIRED('google-translate')(apiKey);
    
    var OriginalTextForDetection = data.inputs.input.OriginalTextForDetection;
    
    //-----Detect Language-----------
    googleTranslate.detectLanguage(OriginalTextForDetection, function(err, reply) {
        if(err){ 
            LOG.info('+++ Error +++');
            var result = JSON.parse(err.body);
            var outp1 = {ErrorMessage: result.error.message};
            LOG.info(outp1);
	        var ferror = RESPONSE(outp1, null , 500);
	        LOG.info(ferror);
	        callback(ferror);
        }else{  
            LOG.info('+++ Success +++');
            var resp = reply.language;
            var outp2 = {LanguageDetected: resp};
            LOG.info(outp2);
            var success = RESPONSE(outp2, null, 200);
            callback(success);
        }
    });
    
}

exports.invoke = invoke;